﻿---------------------------------------------------------------------------------------
-- NxWeekly - Weekly Objective Tracker
-- Copyright 2013 Rythal
--------

local _G = getfenv(0)

CarboniteWeekly = LibStub("AceAddon-3.0"):NewAddon("CarboniteWeekly","AceEvent-3.0","AceComm-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("Carbonite.Weekly", true)

Nx.VERSIONWeek			= .1				-- Warehouse data

local defaults = {
	profile = {
		Weekly = {
			ResetDate = 1,
			SecondsToReset = 0,
		},
		Track = {
			Mob = {
				Sha = true,
				Galleon = true,
				Nalak = true,
				Oondasta = true,
			},
			Loot = { 
				Ritual = true,
				LootKey = true,
				OutdoorChest = true,
			},
			Quest = {
				MoguRune = true,
				Chamberlain = true,
			},
		},
	},
}

Nx.Weekly = {}

local weeklyopts
local function WeeklyOptions()
	if not weeklyopts then
		weeklyopts = {
			type = "group",
			name = "周常状态设置",
			childGroups	= "tab",
			args = {
				general = {
					type = "group",
					name = "综合",
					order = 1,
					args = {
						dateset = {
							order = 1,
							type = "select",
							name = "周常重置日",
							get = function()						
								local num = Nx.wkdb.profile.Weekly.ResetDate
								return num
							end,
							set = function(info,name)
								Nx.wkdb.profile.Weekly.ResetDate = name
							end,
							values = function()
								return {"周二","周三","周四"}
							end,
						},
					},
				},
				Mobs = {
					type = "group",
					name = "世界BOSS",
					order = 2,
					args = {
						mdesc = {
							order = 1,
							type = "description",
							name = "勾选你想要追踪击杀情况的世界BOSS。",
						},
						sha = {
							order = 2,
							type = "toggle",
							width = "full",
							name = "怒之煞",
							get = function()						
								return Nx.wkdb.profile.Track.Mob.Sha								
							end,
							set = function()
								Nx.wkdb.profile.Track.Mob.Sha = not Nx.wkdb.profile.Track.Mob.Sha
							end,
						},
						galleon = {
							order = 3,
							type = "toggle",
							width = "full",
							name = "炮舰",
							get = function()						
								return Nx.wkdb.profile.Track.Mob.Galleon	
							end,
							set = function()
								Nx.wkdb.profile.Track.Mob.Galleon = not Nx.wkdb.profile.Track.Mob.Galleon
							end,
						},
						nalak = {
							order = 4,
							type = "toggle",
							width = "full",
							name = "纳拉克",
							get = function()						
								return Nx.wkdb.profile.Track.Mob.Nalak
							end,
							set = function()
								Nx.wkdb.profile.Track.Mob.Nalak = not Nx.wkdb.profile.Track.Mob.Nalak
							end,
						},
						oondasta = {
							order = 5,
							type = "toggle",
							width = "full",
							name = "乌达斯塔",
							get = function()						
								return Nx.wkdb.profile.Track.Mob.Oondasta
							end,
							set = function()
								Nx.wkdb.profile.Track.Mob.Oondasta = not Nx.wkdb.profile.Track.Mob.Oondasta
							end,
						},						
					},					
				},
				Loot = {
					type = "group",
					name = "可拾取物品",
					order = 3,
					args = {
						ldesc = {
							order = 1,
							type = "description",
							name = "勾选你想要追踪拾取情况的物品。",
						},
						ritual = {
							order = 2,
							type = "toggle",
							width = "full",
							name = "山泽仪式石",
							get = function()						
								return Nx.wkdb.profile.Track.Loot.Ritual								
							end,
							set = function()
								Nx.wkdb.profile.Track.Loot.Ritual = not Nx.wkdb.profile.Track.Loot.Ritual
							end,
						},
						lootkey = {
							order = 3,
							type = "toggle",
							width = "full",
							name = "雷神宫殿钥匙",
							get = function()						
								return Nx.wkdb.profile.Track.Loot.LootKey	
							end,
							set = function()
								Nx.wkdb.profile.Track.Loot.LootKey = not Nx.wkdb.profile.Track.Loot.LootKey
							end,
						},
						ochest = {
							order = 4,
							type = "toggle",
							width = "full",
							name = "雷电之王宝箱",
							get = function()						
								return Nx.wkdb.profile.Track.Loot.OutdoorChest
							end,
							set = function()
								Nx.wkdb.profile.Track.Loot.OutdoorChest = not Nx.wkdb.profile.Track.Loot.OutdoorChest
							end,
						},
					},					
				},
				Quests = {
					type = "group",
					name = "周常任务",
					order = 4,
					args = {
						qdesc = {
							order = 1,
							type = "description",
							name = "勾选你想要追踪完成状况的周常任务。",
						},
						mogurune = {
							order = 2,
							type = "toggle",
							width = "full",
							name = "魔古命运符文",
							get = function()						
								return Nx.wkdb.profile.Track.Quest.MoguRune								
							end,
							set = function()
								Nx.wkdb.profile.Track.Quest.MoguRune = not Nx.wkdb.profile.Track.Quest.MoguRune
							end,
						},
						chamberlain = {
							order = 3,
							type = "toggle",
							width = "full",
							name = "破碎的侍从官",
							get = function()						
								return Nx.wkdb.profile.Track.Quest.Chamberlain	
							end,
							set = function()
								Nx.wkdb.profile.Track.Quest.Chamberlain = not Nx.wkdb.profile.Track.Quest.Chamberlain
							end,
						},
					},													
				},				
				Raids = {
					type = "group",
					name = "团队副本",
					order = 5,
					args = {
						rdesc = {
							order = 1,
							type = "description",
							name = "勾选你想要追踪的团队进度。",
						},
					},													
				},								
			},
		}
	end
	return weeklyopts
end

function CarboniteWeekly:OnInitialize()
	if not Nx.Initialized then
		CarbWeeklyInit = Nx:ScheduleTimer(CarboniteWeekly.OnInitialize,1)
		return
	end
	Nx.wkdb = LibStub("AceDB-3.0"):New("NXWeek",defaults, true)		
	Nx.wkdb:SetProfile(Nx.db:GetCurrentProfile())
	tinsert(Nx.dbs,Nx.wkdb)		
	Nx.Weekly:Init()
	Nx.Weekly:Login()
	local function func ()
		Nx.Weekly:ToggleShow()
	end	
	Nx.NXMiniMapBut.Menu:AddItem(0, "显示周常目标", func, Nx.NXMiniMapBut)			

	CarboniteWeekly:RegisterEvent("PLAYER_LOGIN", "EventHandler")
	CarboniteWeekly:RegisterEvent("PLAYER_LOGOUT", "EventHandler")
	Nx.Button.TypeData["MapWeekly"] = {
		Up = "$Achievement_Faction_craftsman",
		SizeUp = 22,
		SizeDn = 22,
	}

	tinsert (Nx.BarData,{"MapWeekly", "-周常追踪-", Nx.Weekly.OnButToggleWeekly, false })
	Nx.Map.Maps[1]:CreateToolBar()
	local resettime = Nx.Weekly:CalcEpoch()
	if resettime > Nx.wkdb.profile.Weekly.SecondsToReset then
		Nx.wkdb.profile.Weekly.SecondsToReset = resettime + Nx.Weekly:CalcReset()
		Nx.Weekly:Reset()		
	end	
	Nx:AddToConfig("Weekly Status Module",WeeklyOptions(),"周常追踪模块")
	tinsert(Nx.BrokerMenuTemplate,{ text = "切换周常追踪", func = function() Nx.Weekly:ToggleShow() end })
end

function CarboniteWeekly:EventHandler(event, arg1, arg2, arg3)
	if event == "PLAYER_LOGIN" or event == "PLAYER_LOGOUT" then
		Nx.Weekly:Login(event,arg1)
	else
		Nx.prt("ERROR: Event " .. event .. " triggered without function.")
	end	
end

function Nx.Weekly:Init()
	local week = Nx.wkdb.profile.WeeklyData
	if not week or week.Version < Nx.VERSIONWeek then
		if week then
			Nx.prt ("重置旧周常信息 %f", week.Version)
		end
		week = {}
		Nx.wkdb.profile.WeeklyData = week
		week.Version = Nx.VERSIONWeek
	end		
	self.ClassIcons = {
		["Druid"] = "Ability_Druid_Maul",
		["Hunter"] = "INV_Weapon_Bow_07",
		["Mage"] = "INV_Staff_13",
		["Paladin"] = "INV_Hammer_01",
		["Priest"] = "INV_Staff_30",
		["Rogue"] = "INV_ThrowingKnife_04",
		["Shaman"] = "Spell_Nature_BloodLust",
		["Warlock"] = "Spell_Nature_FaerieFire",
		["Warrior"] = "INV_Sword_27",
		["Death Knight"] = "Spell_Deathknight_ClassIcon",
		["Monk"] = "class_monk",
	}
end

--------
-- Debug print

function Nx.Weekly:Login(event, arg1)
	local ch = Nx.CurCharacter
	Nx.Weekly:CharRecord(ch)
end

function Nx.Weekly:Reset()
	for cnum, rc in ipairs (Nx.RealmChars) do
		local ch = Nx.db.global.Characters[rc]
		if ch.Weekly then
			ch.Weekly.Sha = false
			ch.Weekly.Galleon = false
			ch.Weekly.Nalak = false
			ch.Weekly.Oondasta = false
			ch.Weekly.Ritual = false
			ch.Weekly.LootKey = false
			ch.Weekly.OutdoorChest = false
			ch.Weekly.MoguRune = false
			ch.Weekly.Chamberlain = false
		end
	end
end

function Nx.Weekly:CharRecord(ch)
  if not ch.Weekly then
    ch.Weekly = {}
  end  
  if IsQuestFlaggedCompleted(32099) then 
	ch.Weekly.Sha = true
  else
	ch.Weekly.Sha = false
  end
  if IsQuestFlaggedCompleted(32098) then 
	ch.Weekly.Galleon = true
  else
	ch.Weekly.Galleon = false
  end  
  if IsQuestFlaggedCompleted(32518) then 
	ch.Weekly.Nalak = true
  else
	ch.Weekly.Nalak = false
  end  
  if IsQuestFlaggedCompleted(32519) then 
	ch.Weekly.Oondasta = true
  else
	ch.Weekly.Oondasta = false
  end  
  if IsQuestFlaggedCompleted(32610) then 
	ch.Weekly.Ritual = true
  else
	ch.Weekly.Ritual = false
  end  
  if IsQuestFlaggedCompleted(32626) then 
	ch.Weekly.LootKey = true
  else
	ch.Weekly.LootKey = false
  end  
  if IsQuestFlaggedCompleted(32609) then 
	ch.Weekly.OutdoorChest = true
  else
	ch.Weekly.OutdoorChest = false
  end  
  if IsQuestFlaggedCompleted(32718) then
	ch.Weekly.MoguRune = true
  else
	ch.Weekly.MoguRune = false
  end
  if IsQuestFlaggedCompleted(32505) then
	ch.Weekly.Chamberlain = true
  else
	ch.Weekly.Chamberlain = false
  end  
end

--------
-- Create warehouse window

function Nx.Weekly:Create()
	self.SelectedChar = 1
	local win = Nx.Window:Create ("NxWeekly", nil, nil, nil, 1)
	self.Win = win
	win.Frm.NxInst = self
	win:CreateButtons (true, true)
	win:InitLayoutData (nil, -.25, -.15, -.5, -.6)
	win.Frm:SetToplevel (true)

	win:Show (false)

	tinsert (UISpecialFrames, win.Frm:GetName())
	-- Character List

	Nx.List:SetCreateFont ("Font.Medium", 16)

	local list = Nx.List:Create (false, 0, 0, 1, 1, win.Frm)
	self.List = list

	list:SetUser (self, self.OnListEvent)

	list:SetLineHeight (4)

	list:ColumnAdd ("", 1, 24)
	list:ColumnAdd ("角色", 2, 200)
	list:ColumnAdd ("职业", 3,250)
	win:Attach (list.Frm, 0, .5, 0, 1)

	-- Item List

	Nx.List:SetCreateFont ("Font.Medium", 16)

	local list = Nx.List:Create (false, 0, 0, 1, 1, win.Frm)
	self.WeeklyList = list	
	list:ColumnAdd ("", 1, 250)
	list:ColumnAdd ("", 2, 250)
	win:Attach (list.Frm, .5, 1, 0, 1)
	self:Update()
	self.List:Select (0)
	self.List:FullUpdate()
end

--------
-- Show or hide window

function Nx.Weekly:ToggleShow()

	if not self.Win then
		self:Create()
	end

	self.Win:Show (not self.Win:IsShown())

	if self.Win:IsShown() then		
		self:Update()
	end

--PAIDE!
end

--------
-- On list events

function Nx.Weekly:OnListEvent (eventName, sel, val2, click)
	local data = self.List:ItemGetData (sel) or 0
	local id = data % 1000
	if (id >= 1 and id <= #Nx.RealmChars) or id == 99 then
		self.SelectedChar = id
	end

	if eventName == "select" or eventName == "mid" then
		self:Update()
	end
end

--------
-- Update Warehouse

function Nx.Weekly:Update()
	local Nx = Nx
	if not Nx.CurCharacter then	-- Can even happen?
		return
	end
	if not self.Win then
		return
	end
	Nx.Weekly:CharRecord(Nx.CurCharacter)
	self.Win:SetTitle (format ("周常追踪: %d 角色 - 将于 %s 后重置", #Nx.RealmChars,SecondsToTime(Nx.Weekly:CalcReset(), false, true,3)))
	local myName = UnitName ("player")
	local totalChars = 0
	local hicol = "|cffcfcfcf"
	local list = self.List
	list:Empty()
	local allIndex = list:ItemGetNum()
	local rn = GetRealmName()
	for cnum, rc in ipairs (Nx.RealmChars) do
		local rname, cname = strsplit (".", rc)
		local cnameCol = "|cffafdfaf"
		if cname == myName then		-- Me?
			cnameCol = "|cffdfffdf"
		end
		local ch = Nx.db.global.Characters[rc]
		if ch then
			local cls = ch["Class"] or "?"
			cls = NXlClassLocToCap[cls] or cls 
			local lvl = tonumber (ch["Level"] or 0)
			totalChars = totalChars + 1
			list:ItemAdd (cnum)
			local s = ch["Account"] and format ("%s (%s)", cname, ch["Account"]) or cname
			list:ItemSet (2, format ("%s%s", cnameCol, s))
			list:ItemSet (3, format ("|cffff0000[|cff00ffff%s %s|cffff0000]", lvl, cls))
			if self.ClassIcons[ch["Class"]] then
				list:ItemSetButton ("Warehouse", hide, "Interface\\Icons\\" .. self.ClassIcons[ch["Class"]])
			end
		end
	end

	list:Update()
	self:DisplayWeekly()
end

function Nx.Weekly:DisplayWeekly()
	local list = self.WeeklyList
	local strng = ""
	list:Empty()
	local rc = Nx.RealmChars[self.SelectedChar]
	local rname, cname = strsplit (".", rc)
	local curline = 1
	local spacer = false
	list:ColumnSetName (1, format ("  %s的周常状态", cname))
	local ch = Nx.db.global.Characters[rc]	
	if Nx.wkdb.profile.Track.Mob.Sha then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  怒之煞")
		if ch.Weekly and ch.Weekly.Sha then
			strng = "|cff00ff00已击杀"
		elseif ch.Weekly and not ch.Weekly.Sha then
			strng = "|cffff0000未击杀"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Mob.Galleon then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  炮舰")
		if ch.Weekly and ch.Weekly.Galleon then
			strng = "|cff00ff00已击杀"
		elseif ch.Weekly and not ch.Weekly.Galleon then
			strng = "|cffff0000未击杀"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)	
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Mob.Nalak then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  纳拉克")
		if ch.Weekly and ch.Weekly.Nalak then
			strng = "|cff00ff00已击杀"
		elseif ch.Weekly and not ch.Weekly.Nalak then
			strng = "|cffff0000未击杀"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)	
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Mob.Oondasta then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  乌达斯塔")
		if ch.Weekly and ch.Weekly.Oondasta then
			strng = "|cff00ff00已击杀"
		elseif ch.Weekly and not ch.Weekly.Oondasta then
			strng = "|cffff0000未击杀"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)	
		curline = curline + 1
		spacer = true
	end
	if spacer then
		list:ItemAdd(curline)
		list:ItemSet(1,"|cff00ffff  -----------------------------")
		curline = curline + 1
	end
	spacer = false
	if Nx.wkdb.profile.Track.Loot.Ritual then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  山泽仪式石")
		if ch.Weekly and ch.Weekly.Ritual then
			strng = "|cff00ff00已拾取"
		elseif ch.Weekly and not ch.Weekly.Ritual then
			strng = "|cffff0000未拾取"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)		
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Loot.LootKey then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  雷神宫殿钥匙")
		if ch.Weekly and ch.Weekly.LootKey then
			strng = "|cff00ff00已拾取"
		elseif ch.Weekly and not ch.Weekly.LootKey then
			strng = "|cffff0000未拾取"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)		
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Loot.OutdoorChest then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  雷电之王宝箱")
		if ch.Weekly and ch.Weekly.OutdoorChest then
			strng = "|cff00ff00已拾取"
		elseif ch.Weekly and not ch.Weekly.OutdoorChest then
			strng = "|cffff0000未拾取"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)		
		curline = curline + 1
		spacer = true
	end
	if spacer then
		list:ItemAdd(curline)
		list:ItemSet(1,"|cff00ffff  -----------------------------")
	end
	spacer = false
	if Nx.wkdb.profile.Track.Quest.MoguRune then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  魔古命运符文任务")
		if ch.Weekly and ch.Weekly.MoguRune then
			strng = "|cff00ff00已完成"
		elseif ch.Weekly and not ch.Weekly.MoguRune then
			strng = "|cffff0000未完成"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)			
		curline = curline + 1
		spacer = true
	end
	if Nx.wkdb.profile.Track.Quest.Chamberlain then
		list:ItemAdd(curline)
		list:ItemSet(1, "|cffffff00  破碎的侍从官任务")
		if ch.Weekly and ch.Weekly.Chamberlain then
			strng = "|cff00ff00已完成"
		elseif ch.Weekly and not ch.Weekly.Chamberlain then
			strng = "|cffff0000未完成"			
		else
			strng = "|cffffffff未知"
		end
		list:ItemSet(2, strng)						
		curline = curline + 1
		spacer = true
	end
end

function Nx.Weekly:OnButToggleWeekly (but)
	Nx.Weekly:ToggleShow()
end

function Nx.Weekly:CalcEpoch()
	local anum,amonth,aday,ayear = CalendarGetDate()
	local ahour,amin = GetGameTime()		
	return time({year = ayear, month = amonth, day = aday, hour = ahour, min = amin})
end

function Nx.Weekly:CalcReset()
	local seconds = GetQuestResetTime()
	local day = CalendarGetDate()
	local dailydate = Nx.wkdb.profile.Weekly.ResetDate	
	if day - 2 == dailydate-1 then
		if seconds < 21600 then
			return seconds
		end
	end
	local tdays = 0
	if day - 2 == dailydate then tdays = 6 end
	if day - 2 == dailydate+1 then tdays = 5 end
	if day - 2 == dailydate+2 then tdays = 4 end
	if day - 2 == dailydate+3 then tdays = 3 end
	if day - 2 == dailydate+4 then tdays = 2 end
	if day - 2 == dailydate-1 then tdays = 1 end
	if day - 2 == dailydate-2 then tdays = 1 end
	if day - 2 == dailydate-3 then tdays = 2 end
	if day - 2 == dailydate-4 then tdays = 3 end
--	Nx.prt(day .. " " .. dailydate .. " " .. tdays)
	return seconds + tdays * 86400	
end